"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

require("./FlipCard.css");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var FlipCard =
/*#__PURE__*/
function (_Component) {
  _inherits(FlipCard, _Component);

  function FlipCard() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, FlipCard);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(FlipCard)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "handleOnClick", function () {
      var onCardClick = _this.props.onCardClick;
      onCardClick();
    });

    return _this;
  }

  _createClass(FlipCard, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          frontContent = _this$props.frontContent,
          backContent = _this$props.backContent,
          width = _this$props.width,
          height = _this$props.height,
          perspective = _this$props.perspective,
          frontCardStyle = _this$props.frontCardStyle,
          backCardStyle = _this$props.backCardStyle,
          cardContainerStyle = _this$props.cardContainerStyle,
          horizontal = _this$props.horizontal;
      var cardClasses = (0, _classnames.default)('card', {
        'card__flipped--horizontal': this.props.flipped && this.props.horizontal,
        card__flipped: this.props.flipped
      });
      var backCardClass = (0, _classnames.default)('card__face card__face--back ', {
        'card__flipped--horizontal': horizontal
      });
      return _react.default.createElement("div", {
        className: "frame",
        style: {
          width: width,
          height: height,
          perspective: perspective
        }
      }, _react.default.createElement("div", {
        className: cardClasses,
        style: _objectSpread({}, cardContainerStyle),
        onClick: this.handleOnClick
      }, _react.default.createElement("div", {
        className: "card__face card__face--front",
        style: _objectSpread({}, frontCardStyle)
      }, frontContent), _react.default.createElement("div", {
        className: backCardClass,
        style: _objectSpread({}, backCardStyle)
      }, backContent)));
    }
  }]);

  return FlipCard;
}(_react.Component);

FlipCard.propTypes = {
  frontContent: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.element]).isRequired,
  backContent: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.element]).isRequired,
  width: _propTypes.default.string,
  height: _propTypes.default.string,
  flipDuration: _propTypes.default.number,
  horizontal: _propTypes.default.bool
};
FlipCard.defaultProps = {
  height: '260px',
  width: '200px',
  perspective: '1000px',
  flipDuration: 1,
  vertical: true,
  frontContent: 'This is front',
  backContent: 'This is back',
  frontCardStyle: {
    background: '#d41f42'
  },
  backCardStyle: {
    background: '#2e508b'
  }
};
var _default = FlipCard;
exports.default = _default;